Event = {
none = FL_NO_EVENT,
push =  FL_PUSH,
release =  FL_RELEASE,
enter =  FL_ENTER,
leave =  FL_LEAVE,
drag =  FL_DRAG,
focus =  FL_FOCUS,
unfocus =  FL_UNFOCUS,
keyboard =  FL_KEYBOARD,
close =  FL_CLOSE,
move =  FL_MOVE,
shortcut =  FL_SHORTCUT,
deactivate =  FL_DEACTIVATE,
activate =  FL_ACTIVATE,
hide =  FL_HIDE,
show =  FL_SHOW,
paste =  FL_PASTE,
selectionclear =  FL_SELECTIONCLEAR
}

When = {
never =  FL_WHEN_NEVER,
changed =  FL_WHEN_CHANGED,
release =  FL_WHEN_RELEASE,
release_always =  FL_WHEN_RELEASE_ALWAYS,
enter_key =  FL_WHEN_ENTER_KEY,
enter_key_always =  FL_WHEN_ENTER_KEY_ALWAYS,
enter_key_changed =  FL_WHEN_ENTER_KEY_CHANGED,
not_changed = FL_WHEN_NOT_CHANGED
}

-- not yet
-- Key = {}

Boxtype = {
   none=FL_NO_BOX,
   flat=FL_FLAT_BOX,
   up=FL_UP_BOX,
   down=FL_DOWN_BOX,
   thin_up=FL_THIN_UP_BOX, 
   thin_down=FL_THIN_DOWN_BOX,
   engraved=FL_ENGRAVED_BOX,
   embossed=FL_EMBOSSED_BOX,
   border=FL_BORDER_BOX,
   shadow=FL_SHADOW_BOX,
   rounded=FL_ROUNDED_BOX,
   rshadow=FL_RSHADOW_BOX,
   rflat=FL_RFLAT_BOX,
   round_up=FL_ROUND_UP_BOX,
   round_down=FL_ROUND_DOWN_BOX,
   diamond_up=FL_DIAMOND_UP_BOX,
   diamond_down=FL_DIAMOND_DOWN_BOX,
   oval=FL_OVAL_BOX,
   oshadow=FL_OSHADOW_BOX
}

Frametype = {
   none=FL_NO_BOX,
   flat=FL_FLAT_FRAME,
   up=FL_UP_FRAME,
   down=FL_DOWN_FRAME,
   thin_up=FL_THIN_UP_FRAME, 
   thin_down=FL_THIN_DOWN_FRAME,
   engraved=FL_ENGRAVED_FRAME,
   embossed=FL_EMBOSSED_FRAME,
   border=FL_BORDER_FRAME,
   shadow=FL_SHADOW_FRAME,
   rounded=FL_ROUNDED_FRAME,
   rshadow=FL_RSHADOW_FRAME,
   rflat=FL_RFLAT_FRAME,
   round_up=FL_ROUND_UP_FRAME,
   round_down=FL_ROUND_DOWN_FRAME,
   diamond_up=FL_DIAMOND_UP_FRAME,
   diamond_down=FL_DIAMOND_DOWN_FRAME,
   oval=FL_OVAL_FRAME,
   oshadow=FL_OSHADOW_FRAME
}

Labeltype = {
  normal=FL_NORMAL_LABEL,
  no=FL_NO_LABEL,
  symbol=FL_SYMBOL_LABEL,
  shadow=FL_SHADOW_LABEL,
  engraved=FL_ENGRAVED_LABEL,
  embossed=FL_EMBOSSED_LABEL,
  bitmap=FL_BITMAP_LABEL,
  pixmap=FL_PIXMAP_LABEL,
  image=FL_IMAGE_LABEL,
  multi=FL_MULTI_LABEL,
}

Align = {
   center=FL_ALIGN_CENTER,
   top= FL_ALIGN_TOP,
   bottom = FL_ALIGN_BOTTOM,
   left = FL_ALIGN_LEFT,
   right = FL_ALIGN_RIGHT,
   inside = FL_ALIGN_INSIDE,
   clip = FL_ALIGN_CLIP, 
   wrap = FL_ALIGN_WRAP,
   top_left = FL_ALIGN_TOP_LEFT,
   top_right = FL_ALIGN_TOP_RIGHT,
   bottom_left = FL_ALIGN_BOTTOM_LEFT,
   bottom_right = FL_ALIGN_BOTTOM_RIGHT,
   left_top = FL_ALIGN_LEFT_TOP,
   right_top = FL_ALIGN_RIGHT_TOP,
   left_bottom = FL_ALIGN_LEFT_BOTTOM,
   right_bottom = FL_ALIGN_RIGHT_BOTTOM
}

Font = {
   helvetica = FL_HELVETICA,
   courier = FL_COURIER,
   times =   FL_TIMES,
   symbol = FL_SYMBOL,
   screen = FL_SCREEN,
   zapf_dingbats = FL_ZAPF_DINGBATS,

   bold = FL_BOLD, -- allowed for helvetica, courier, times, and screen
  italic = FL_ITALIC -- allowed for helvetica, courier, and times
}

Color = {
   black = FL_BLACK,
   red = FL_RED,
   green = FL_GREEN,
   yellow = FL_YELLOW,
   blue = FL_BLUE,
   magenta = FL_MAGENTA,
   cyan = FL_CYAN,
   white = FL_WHITE,
   inactive = FL_INACTIVE_COLOR,
   selection = FL_SELECTION_COLOR,

   gray_ramp = FL_GRAY_RAMP,
   num_gray = FL_NUM_GRAY,

  -- // boxtypes limit themselves to these colors so whole ramp is not allocated:

   gray0 = FL_GRAY0,
   dark3 = FL_DARK3,
   dark2 = FL_DARK2,
   dark1 = FL_DARK1,
   gray = FL_GRAY,
   light1 = FL_LIGHT1,
   light2 = FL_LIGHT2,
   light3 = FL_LIGHT3,

   color_cube = FL_COLOR_CUBE,
   num_red = FL_NUM_RED,
   num_green = FL_NUM_GREEN,
   num_blue = FL_NUM_BLUE
}

Cursor = {
   default = FL_CURSOR_DEFAULT,
   arrow = FL_CURSOR_ARROW,
   cross = FL_CURSOR_CROSS,
   wait = FL_CURSOR_WAIT,
   insert = FL_CURSOR_INSERT,
   hand = FL_CURSOR_HAND,
   help = FL_CURSOR_HELP,
   move = FL_CURSOR_MOVE,
  -- // fltk provides bitmaps for these:
   ns = FL_CURSOR_NS,
   we = FL_CURSOR_WE,
   nwse = FL_CURSOR_NWSE,
   nesw = FL_CURSOR_NESW,
   none = FL_CURSOR_NONE,
  -- // for back compatability (non MSWindows ones):
   n = FL_CURSOR_N,
   ne = FL_CURSOR_NE,
   e = FL_CURSOR_E,
   se = FL_CURSOR_SE,
   s = FL_CURSOR_S,
   sw = FL_CURSOR_SW,
   w = FL_CURSOR_W,
   nw = FL_CURSOR_NW
}

Damage = {
   child = FL_DAMAGE_CHILD,
   expose = FL_DAMAGE_EXPOSE,
   scroll = FL_DAMAGE_SCROLL,
   overlay = FL_DAMAGE_OVERLAY,
   all = FL_DAMAGE_ALL
}

Scrolltype = {
   horizontal=Fl_Scroll.HORIZONTAL,
   vertical=Fl_Scroll.VERTICAL,
   both=Fl_Scroll.BOTH,
   always_on=Fl_Scroll.ALWAYS_ON,
   horizontal_always=Fl_Scroll.HORIZONTAL_ALWAYS,
   vertical_always=Fl_Scroll.VERTICAL_ALWAYS,
   both_always=Fl_Scroll.BOTH_ALWAYS
}

Packtype = {
   vertical=Fl_Pack.VERTICAL,
   horizontal=Fl_Pack.HORIZONTAL
}


Buttontype = {
   toggle=FL_TOGGLE_BUTTON,
   radio=FL_RADIO_BUTTON,
   hidden=FL_HIDDEN_BUTTON
}

